this.name        = "Automatic Chaff System"; 
this.author      = "Origional code snips by Thargoid and Screet, modified and adapted by Wyvern for ACS"; 
this.copyright   = " 2010 the Oolite team."; 
this.description = "Automatic Chaff System - An improved, smarter missile countermeasures system with ECM control and magazine-fed, 25-round chaff dispenser."; 
this.version     = "1.2 - for Oolite 1.74"; 

this.startUp =  function() {
	if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK")
	 {
	this.acsCount = 25;
	}
	if(!missionVariables.acsCount)
	{
	missionVariables.acsCount = 25;
	}
}

this.shipLaunchedFromStation = this.shipExitedWitchspace = function()
   {
   if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK")
   {
      this.acsCount = missionVariables.acsCount; // required to prevent "auto refill" after save/quit/load/launch
      switch(this.acsCount)
         {
         case "0":
            {
            player.consoleMessage("ACS - Magazine empty.",5);
            break;
            }
         case "1":
            {
            player.consoleMessage("ACS - System ready, 1 package loaded.",5);
            break;
            }
         default:
            {
            player.consoleMessage("ACS - System ready, " + this.acsCount + " packages loaded.",5);
            break;
            }
         }
      }
   }

this.shipAttackedWithMissile = function(missile, whom) {
	if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ECM") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_MISSILE_ANALYSER") == "EQUIPMENT_OK" && missile.name == "Missile" || missile.name == "Military Missile") { // If enemy missile is Standard  or Military type?
		player.ship.fireECM();
		player.consoleMessage("ACS - ECM triggered.",6);
		} // Use ECM. Military missile is a hardened fire-and-forget missile that goes "crazy ivan" and attacks pirates and Thargoids when ECM'd, thusly no chaff is wasted on it unless the ECM has been battledamaged.
	else if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_MISSILE_ANALYSER") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ECM") == "EQUIPMENT_OK" && missile.name == "Missile" && missile.name != "Missile" && this.acsCount < 1) { //  Out of ammo?
		player.ship.target = missile;
		player.consoleMessage("ACS - Magazine empty.",6);
		player.ship.fireECM();
		player.consoleMessage("ACS - ECM triggered.",6);
		} // Target the enemy missile, use ECM and hope to pop the missile.
	else if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_MISSILE_ANALYSER") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ECM") == "EQUIPMENT_DAMAGED" && missile.name == "Missile" && missile.name != "Missile" && this.acsCount < 1) { // ECM N/A and mag empty?
		player.ship.target = missile;
		player.consoleMessage("ACS - Magazine empty.",6);
		player.consoleMessage("ACS - ECM N/A.",6);
		player.consoleMessage("ACS - DANGER: Manual countermeasures recommended!",6);
		} // Target the enemy missile. Panic!!
	else if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_MISSILE_ANALYSER") == "EQUIPMENT_DAMAGED" && player.ship.equipmentStatus("EQ_ECM") == "EQUIPMENT_DAMAGED" && missile.name == "Missile" && missile.name != "Missile" && this.acsCount < 1) { // ECM and Analyzer N/A and mag empty?
		player.consoleMessage("ACS - Magazine empty.",6);
		player.consoleMessage("ACS - ECM N/A.",6);
		player.consoleMessage("ACS - DANGER: Manual countermeasures recommended!",6);
		} // Panic!!
	else if(player.ship.equipmentStatus("EQ_ACS") && player.ship.equipmentStatus("EQ_MISSILE_ANALYSER") == "EQUIPMENT_DAMAGED" && player.ship.equipmentStatus("EQ_ECM") == "EQUIPMENT_DAMAGED" && missile.name == "Missile" && missile.name != "Missile" && this.acsCount > 0) { // ECM and Analyzer N/A? Deploy chaff if we have any.
		player.consoleMessage("ACS - ECM N/A.",6);
		system.legacy_addShipsWithinRadius("acs_package", 1, "abs", player.ship.position.subtract(player.ship.orientation.vectorUp().multiply(20)), 10);
		if(--this.acsCount < 1)
			{
			player.consoleMessage("ACS - Magazine empty.",6);
			}
		missionVariables.acsCount = this.acsCount;
		}
	else if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_MISSILE_ANALYSER") == "EQUIPMENT_DAMAGED" && player.ship.equipmentStatus("EQ_ECM") == "EQUIPMENT_OK" && missile.name == "Missile" && missile.name != "Missile" && this.acsCount > 0) { //  If Analyzer is N/A? Deploy chaff, fire ECM.
		player.ship.fireECM();
		player.consoleMessage("ACS - ECM triggered.",6);
		system.legacy_addShipsWithinRadius("acs_package", 1, "abs", player.ship.position.subtract(player.ship.orientation.vectorUp().multiply(20)), 10);
		if(--this.acsCount < 1)
			{
			player.consoleMessage("ACS - Magazine empty.",6);
			}
		missionVariables.acsCount = this.acsCount;
		}
	else if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_MISSILE_ANALYSER") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ECM") == "EQUIPMENT_OK" && missile.name != "Missile" || missile.name != "Military Missile" && this.acsCount > 0 ) { // Deploy chaff for Hardened and other, possibly ECM resistant enemy missiles and torpedoes, with a caveat for the military missile. ECM the military missile instead, if possible.
		system.legacy_addShipsWithinRadius("acs_package", 1, "abs", player.ship.position.subtract(player.ship.orientation.vectorUp().multiply(20)), 10);
		if(--this.acsCount < 1)
			{
			player.consoleMessage("ACS - Magazine empty.",6);
			}
		missionVariables.acsCount = this.acsCount;
		}
	else if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_MISSILE_ANALYSER") == "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ECM") == "EQUIPMENT_DAMAGED" && missile.name == "Missile" && missile.name != "Missile" && this.acsCount > 0 ) { // ECM N/A? Fall back to chaff instead, including for Standard and Military missiles.
		player.ship.target = missile;
		system.legacy_addShipsWithinRadius("acs_package", 1, "abs", player.ship.position.subtract(player.ship.orientation.vectorUp().multiply(20)), 10);
		if(--this.acsCount < 1)
			{
			player.consoleMessage("ACS - Magazine empty.",6);
			}
		missionVariables.acsCount = this.acsCount;
		}
	}

this.guiScreenChanged = function()
	{ // Displays chaff ammo count on the manifest screen.
   if(player.ship.equipmentStatus("EQ_ACS") == "EQUIPMENT_OK" && guiScreen == "GUI_SCREEN_STATUS") 
	{
	  this.chaffAmmo = "ACS_ammo_status_" + missionVariables.acsCount;
      mission.setInstructionsKey(this.chaffAmmo);
	} else {
	  mission.setInstructionsKey(null)
	}
}

this.playerBoughtEquipment = function(equipment)
	{
	switch(equipment)
		{
		case "EQ_ACS_CHAFF": {
			player.ship.removeEquipment("EQ_ACS_CHAFF");
			player.credits += (-20 + (missionVariables.acsCount * 30));
			this.acsCount = 25;
			missionVariables.acsCount = 25;
            break;
			}
		case "EQ_ACS": {
			this.acsCount = 25;
			missionVariables.acsCount = 25;
            break;
			}
		case "EQ_ACS_REMOVAL":
			{
			player.ship.removeEquipment("EQ_ACS");
			player.ship.removeEquipment("EQ_ACS_REMOVAL");
			player.credits += (2000 + (missionVariables.acsCount * 30));
			this.acsCount = 0;
			missionVariables.acsCount = 0;
			break;
			}
		}
	}